"""
=================================================
@Project -> File    ：my_way_of_python -> redis_curd
@IDE                ：PyCharm
@Author             ：Mr.chao
@Date               ：2021/6/8 下午2:43
@用途               ：
@email              ：chz970511@163.com
==================================================
"""

import redis


class RedisConnect:
    def __init__(self):
        pool = redis.ConnectionPool(host='localhost', port=6379, decode_responses=True)
        self.rd = redis.Redis(connection_pool=pool)


class StringAction(RedisConnect):
    def create_one(self, key, value):
        self.rd.set(key, value, ex=10)

    def create_more(self, mapping):
        self.rd.mset(mapping)

    def get(self, key):
        return self.rd.get(key)

    def get_more(self, mapping):
        return self.rd.mget(mapping)

    def delete(self, key):
        self.rd.delete(key)


def str_action():
    # --------string--------
    in_key = 'name'
    in_value = 'cao'
    data = {
        "k1": "v1",
        "k2": "v2",
    }
    RedisConnect()
    s = StringAction()
    s.create_one(in_key, in_value)
    v1 = s.get(in_key)
    print(v1)
    s.create_more(data)
    v2 = s.get_more(data.keys())
    print(v2)
    s.delete('k1')
    v3 = s.get('k1')
    print(v3)


class HashAction(RedisConnect):
    def create_one(self, key, field, value):
        self.rd.hset(key, field, value)

    def create_more(self, key, mapping):
        self.rd.hmset(key, mapping)

    def get(self, key, field):
        return self.rd.hget(key, field)

    def get_more(self, key, *args):
        return self.rd.hmget(key, *args)

    def delete(self, key, *fields):
        self.rd.hdel(key, *fields)


def hash_action():
    key = 'name'
    field = 'a'
    value = 'A'
    RedisConnect()
    h = HashAction()
    h.create_one(key, field, value)
    v1 = h.get(key, field)
    print(v1)
    data = {
        "name_1": "Jack",
        "age": 20,
        "gender": "M",
    }
    h.create_more(key, data)
    v2 = h.get_more(key, 'name_1', 'age')
    print(v2)
    h.delete(key, 'age', 'name_1')
    v3 = h.get_more(key, 'name_1', 'age')
    print(v3)


if __name__ == '__main__':
    # str_action()
    hash_action()
